#!perl

use Test::More tests => 21;
use AutoClass;

ok(1, "Partial credit just for showing up");

my $obj = AutoClass->new(size => "bigger than a breadbox");
ok($obj, "created object");

ok(! defined &AutoClass::get_color, "get_color method should not exist");
ok(! defined &AutoClass::set_color, "set_color method should not exist");
is ($obj->get_color, undef, "color initially undefined");
ok(  defined &AutoClass::get_color, "get_color method should exist");
ok(! defined &AutoClass::set_color, "set_color method should not exist");
$obj->set_color("red");
is ($obj->get_color, "red", "color set to red");
ok(  defined &AutoClass::get_color, "get_color method should exist");
ok(  defined &AutoClass::set_color, "set_color method should exist");

ok(! defined &AutoClass::get_size, "get_size method should not exist");
ok(! defined &AutoClass::set_size, "set_size method should not exist");
is ($obj->get_size, "bigger than a breadbox", "size initially correct");
ok(  defined &AutoClass::get_size, "get_size method should exist");
ok(! defined &AutoClass::set_size, "set_size method should not exist");
$obj->set_size("very big");
is ($obj->get_size, "very big", "size set to very big");
ok(  defined &AutoClass::get_size, "get_size method should exist");
ok(  defined &AutoClass::set_size, "set_size method should exist");

is ($obj->get_color, "red", "color is still red");

eval { $obj->get_number_of_nosehairs };
warn "# number_of_nosehairs -> $@\n";
ok($@, "non-attribute method should fail");

undef $obj;
ok(not(defined &AutoClass::DESTROY), "nongenerated DESTROY method");

1;



