
use Test::More tests => 8;
my %EXTANT;
sub extant () { scalar keys %EXTANT }

ok(1, "Partial  credit for showing up");

my $animals = DDTree->new('Dummy');
$EXTANT{"$animals"} = 1;
undef $animals;
is(extant, 0, "all objects destroyed");

$animals = Tree->new('Parent', Tree->new('Child'));
note_all($animals);
is(extant, 2, "created small tree of animals");
undef $animals;
is(extant, 2, "leaked");
%EXTANT = ();

$animals = DDTree->new('Parent', DDTree->new('Child'));
note_all($animals);
is(extant, 2, "created small tree of DDanimals");
undef $animals;
is(extant, 0, "no leak");


$animals = DDTree->new('Animal', 
                       DDTree->new('Dogs',
                                   DDTree->new('Snoopy'),
                                   DDTree->new('Lassie'),
                                   DDTree->new('Laika'),
                                  ),
                       DDTree->new('Cats',
                                   DDTree->new('Socks'),
                                  )
                      );
note_all($animals);
is(extant, 7, "large tree");
undef $animals;
is(extant, 0, "large tree cleaned up");



sub note_all {
  my $self = shift;
  $EXTANT{"$self"} = 1;
  for my $node ($self->children) {
    note_all($node);
  }
}

package DDTree;
use base DTree;

sub DESTROY {
  my $self = shift;
  if (delete $EXTANT{"$self"}) {
    return;
  } else {
    my $data = $self->data;
    warn "Non-extant object '$data' ($self) destroyed]\n";
  }
}
